Attribute VB_Name = "modGFX"
Public Declare Function SetPixel Lib "gdi32" (ByVal hDC As Long, _
    ByVal nX As Long, _
    ByVal nY As Long, _
    ByVal crColor As Long) As Long

Public Declare Function SetPixelV Lib "gdi32" (ByVal hDC As Long, _
    ByVal nX As Long, _
    ByVal nY As Long, _
    ByVal crColor As Long) As Long

Public Declare Function GetPixel Lib "gdi32" (ByVal hDC As Long, _
    ByVal nX As Long, _
    ByVal nY As Long) As Long

Declare Function StretchBlt Lib "gdi32" (ByVal hDC As Long, _
    ByVal nX As Long, _
    ByVal nY As Long, _
    ByVal nWidth As Long, _
    ByVal nHeight As Long, _
    ByVal hSrcDC As Long, _
    ByVal xSrc As Long, _
    ByVal ySrc As Long, _
    ByVal nSrcWidth As Long, _
    ByVal nSrcHeight As Long, _
    ByVal dwRop As Long) As Long

Public Declare Function BitBlt Lib "gdi32" ( _
    ByVal hDC As Long, _
    ByVal nX As Long, _
    ByVal nY As Long, _
    ByVal nWidth As Long, _
    ByVal nHeight As Long, _
    ByVal hSrcDC As Long, _
    ByVal xSrc As Long, _
    ByVal ySrc As Long, _
    ByVal dwRop As Long) As Long


' Creates a memory DC
Private Declare Function CreateCompatibleDC Lib "gdi32" ( _
    ByVal hDC As Long) As Long
' Creates a bitmap in memory
Private Declare Function CreateCompatibleBitmap Lib "gdi32" ( _
    ByVal hDC As Long, _
    ByVal nWidth As Long, _
    ByVal nHeight As Long) As Long
' Places a GDI Object into DC, returning the previous one:
Private Declare Function SelectObject Lib "gdi32" ( _
    ByVal hDC As Long, _
    ByVal hObject As Long) As Long
' Deletes a GDI Object:
Private Declare Function DeleteObject Lib "gdi32" ( _
    ByVal hObject As Long) As Long
' Sets the backcolour of a device context
Private Declare Function SetBkColor Lib "gdi32" ( _
    ByVal hDC As Long, _
    ByVal crColor As Long) As Long



Private Declare Function GetDIBits Lib "GDI32.dll" (ByVal aHDC As Long, _
    ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, _
    ByRef lpBits As Any, ByRef lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Private Declare Function SetDIBits Lib "GDI32.dll" (ByVal hDC As Long, _
    ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, _
    ByRef lpBits As Any, ByRef lpBI As BITMAPINFO, ByVal wUsage As Long) As Long

Public Type BITMAPFILEHEADER
   bfType As Integer
   bfSize As Long
   bfReserved1 As Integer
   bfReserved2 As Integer
   bfOffBits As Long
End Type

Public Type BITMAPINFOHEADER ' 40 bytes
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Public Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors(255) As Long
End Type

Public Type BITMAPRGB
    r As Byte
    g As Byte
    b As Byte
End Type


    
'Constants used by the BitBlt Function
Public Const SRCAND = &H8800C6
Public Const SRCCOPY = &HCC0020
Public Const SRCERASE = &H440328
Public Const SRCINVERT = &H660046
Public Const SRCPAINT = &HEE0086


Public Const NES_SIZEOFTILE = 16        ' 2bpp
Public Const REND_SIZEOFTILE = 64       ' 8bpp
Public Const REND_SIZEOFROW = 1024      ' 8bpp

Public NESPAL_LONG(&H3F) As Long


Option Explicit

















'#############################################################################################
'#
'#
'#
Public Function refresh_NESPAL_LONG()
    Dim i As Integer
    For i = 0 To &H3F
        NESPAL_LONG(i) = Hex2Color(i, 0, 0)
    Next i
End Function















'#############################################################################################
' same as "draw2BPPTile", except this version uses cached
' palette values ("NESPAL_LONG(&H3F)") and draws a line
' of pixels at a time.
'
'   to draw 4096 tiles, using timeGetTime() to time:
'       1034ms <- draw2BPPTile
'       498ms  <- draw2BPPTile_Fast
Public Function draw2BPPTile_Fast( _
    tiles() As Byte, ByVal tileID As Byte, _
    panel As PictureBox, ByVal destX As Long, ByVal destY As Long, _
    pal() As Byte, ByVal paletteIndex As Integer)

    Dim srcaddr As Long
    Dim Y As Integer, yoffset As Integer
    Dim pixelval As Byte
    Dim paloffset As Byte
    
    srcaddr = (tileID * REND_SIZEOFTILE)
    paloffset = ((paletteIndex And 7) * 4)
    
    For Y = 0 To 7
    
        yoffset = Y * 8
    
        pixelval = (tiles(srcaddr + 0 + yoffset) And 3)
        SetPixelV panel.hDC, destX + 0, destY + Y, NESPAL_LONG(pal(paloffset + pixelval))
        
        pixelval = (tiles(srcaddr + 1 + yoffset) And 3)
        SetPixelV panel.hDC, destX + 1, destY + Y, NESPAL_LONG(pal(paloffset + pixelval))
        
        pixelval = (tiles(srcaddr + 2 + yoffset) And 3)
        SetPixelV panel.hDC, destX + 2, destY + Y, NESPAL_LONG(pal(paloffset + pixelval))
        
        pixelval = (tiles(srcaddr + 3 + yoffset) And 3)
        SetPixelV panel.hDC, destX + 3, destY + Y, NESPAL_LONG(pal(paloffset + pixelval))
        
        pixelval = (tiles(srcaddr + 4 + yoffset) And 3)
        SetPixelV panel.hDC, destX + 4, destY + Y, NESPAL_LONG(pal(paloffset + pixelval))
        
        pixelval = (tiles(srcaddr + 5 + yoffset) And 3)
        SetPixelV panel.hDC, destX + 5, destY + Y, NESPAL_LONG(pal(paloffset + pixelval))
        
        pixelval = (tiles(srcaddr + 6 + yoffset) And 3)
        SetPixelV panel.hDC, destX + 6, destY + Y, NESPAL_LONG(pal(paloffset + pixelval))
        
        pixelval = (tiles(srcaddr + 7 + yoffset) And 3)
        SetPixelV panel.hDC, destX + 7, destY + Y, NESPAL_LONG(pal(paloffset + pixelval))

    Next Y
    
    draw2BPPTile_Fast = 0

End Function








Public Function drawPatternTable( _
    panel As PictureBox, _
    tiles() As Byte, pal() As Byte, _
    ByVal palIndex As Byte, Optional scaleIndex = 1)

    Dim addr As Long
    Dim X As Integer, Y As Integer
    
    panel.Cls
    For Y = 0 To 15
        For X = 0 To 15
            addr = (REND_SIZEOFROW * Y) + (REND_SIZEOFTILE * X)
            Call draw2BPPTile_Fast(tiles(), (Y * &H10) + X, panel, (X * 8), (Y * 8), _
                    pal(), palIndex)
        Next X
    Next Y
    
    StretchBlt panel.hDC, 0, 0, (256 * scaleIndex), (256 * scaleIndex), _
        panel.hDC, 0, 0, 256, 256, SRCCOPY
    
    panel.Refresh

End Function



























'#############################################################################################
'
' draws all metatiles using an array of PictureBox
' already rendered in the 4 bkg palettes (faster)
Public Function drawMetatiles(panel As PictureBox, rom() As Byte, _
                              parent As Form, _
                              Optional palID = 0)

    Dim Y As Integer, X As Integer
    Dim dX As Long, dY As Long
    Dim addr As Long, tileID As Byte

    panel.Cls: panel.Visible = False
    For Y = 0 To 8
        dY = Y * 32
        For X = 0 To 15
            dX = X * 32
            addr = METADATA_ADDR + (((Y * &H10&) + X) * &H10&)
    
            ' row 0
            tileID = rom(addr + 0)
            BitBlt panel.hDC, dX + 0, dY + 0, 8, 8, _
                   parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 1)
            BitBlt panel.hDC, dX + 8, dY + 0, 8, 8, _
                   parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 2)
            BitBlt panel.hDC, dX + 16, dY + 0, 8, 8, _
                   parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 3)
            BitBlt panel.hDC, dX + 24, dY + 0, 8, 8, _
                   parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
        
            ' row 1
            tileID = rom(addr + 4)
            BitBlt panel.hDC, dX + 0, dY + 8, 8, 8, _
                   parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 5)
            BitBlt panel.hDC, dX + 8, dY + 8, 8, 8, _
                   parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 6)
            BitBlt panel.hDC, dX + 16, dY + 8, 8, 8, _
                   parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 7)
            BitBlt panel.hDC, dX + 24, dY + 8, 8, 8, _
                   parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            
            ' row 2
            tileID = rom(addr + 8)
            BitBlt panel.hDC, dX + 0, dY + 16, 8, 8, _
                   parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 9)
            BitBlt panel.hDC, dX + 8, dY + 16, 8, 8, _
                   parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 10)
            BitBlt panel.hDC, dX + 16, dY + 16, 8, 8, _
                   parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 11)
            BitBlt panel.hDC, dX + 24, dY + 16, 8, 8, _
                   parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            
            ' row 3
            tileID = rom(addr + 12)
            BitBlt panel.hDC, dX + 0, dY + 24, 8, 8, _
                   parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 13)
            BitBlt panel.hDC, dX + 8, dY + 24, 8, 8, _
                   parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 14)
            BitBlt panel.hDC, dX + 16, dY + 24, 8, 8, _
                   parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 15)
            BitBlt panel.hDC, dX + 24, dY + 24, 8, 8, _
                   parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            
            If ((Y = 8) And (X >= 4)) Then Exit For
        Next X
    Next Y
    panel.Visible = True: panel.Refresh

End Function


' draws a single metatile using chr() and pal(), no blit (slower)
Public Function drawMetatile(panel As PictureBox, _
                              rom() As Byte, nchr() As Byte, npal() As Byte, _
                              ByVal dX As Integer, ByVal dY As Integer, _
                              ByVal metaID As Byte, _
                              Optional palID = 0)
    Dim addr As Long

    addr = METADATA_ADDR + (metaID * &H10&)
    draw2BPPTile_Fast nchr(), rom(addr + 0), panel, dX + 0, dY + 0, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 1), panel, dX + 8, dY + 0, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 2), panel, dX + 16, dY + 0, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 3), panel, dX + 24, dY + 0, npal(), palID
    
    draw2BPPTile_Fast nchr(), rom(addr + 4), panel, dX + 0, dY + 8, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 5), panel, dX + 8, dY + 8, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 6), panel, dX + 16, dY + 8, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 7), panel, dX + 24, dY + 8, npal(), palID
    
    draw2BPPTile_Fast nchr(), rom(addr + 8), panel, dX + 0, dY + 16, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 9), panel, dX + 8, dY + 16, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 10), panel, dX + 16, dY + 16, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 11), panel, dX + 24, dY + 16, npal(), palID

    draw2BPPTile_Fast nchr(), rom(addr + 12), panel, dX + 0, dY + 24, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 13), panel, dX + 8, dY + 24, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 14), panel, dX + 16, dY + 24, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 15), panel, dX + 24, dY + 24, npal(), palID

End Function







'#############################################################################################
'
' draws field using an array of PictureBox
' already rendered in the 4 bkg palettes (faster)
Public Function drawField(panel As PictureBox, rom() As Byte, _
                            parent As Form)

    Dim Y As Integer, X As Integer
    Dim dX As Long, dY As Long
    Dim addr As Long
    Dim metaID As Byte, tileID As Byte, palID As Byte, attByte As Byte

    panel.Cls: panel.Visible = False
    For Y = 0 To 23
        dY = Y * 32
        For X = 0 To 23
            dX = X * 32

            metaID = rom(MAPDATA_ADDR + (Y * 24) + X)
            attByte = rom(ATTDATA_ADDR + (Y * 24) + X)
            addr = METADATA_ADDR + (metaID * &H10&)

            ' up-left
            palID = (attByte And &H3)
            tileID = rom(addr + 0)
                BitBlt panel.hDC, dX + 0, dY + 0, 8, 8, _
                parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 1)
                BitBlt panel.hDC, dX + 8, dY + 0, 8, 8, _
                parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 4)
                BitBlt panel.hDC, dX + 0, dY + 8, 8, 8, _
                parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 5)
                BitBlt panel.hDC, dX + 8, dY + 8, 8, 8, _
                parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            
            ' up-right
            palID = (attByte And &HC) \ &H4
            tileID = rom(addr + 2)
                BitBlt panel.hDC, dX + 16, dY + 0, 8, 8, _
                parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 3)
                BitBlt panel.hDC, dX + 24, dY + 0, 8, 8, _
                parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 6)
                BitBlt panel.hDC, dX + 16, dY + 8, 8, 8, _
                parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 7)
                BitBlt panel.hDC, dX + 24, dY + 8, 8, 8, _
                parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            
            ' down-left
            palID = (attByte And &H30) \ &H10
            tileID = rom(addr + 8)
                BitBlt panel.hDC, dX + 0, dY + 16, 8, 8, _
                parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 9)
                BitBlt panel.hDC, dX + 8, dY + 16, 8, 8, _
                parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 12)
                BitBlt panel.hDC, dX + 0, dY + 24, 8, 8, _
                parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 13)
                BitBlt panel.hDC, dX + 8, dY + 24, 8, 8, _
                parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            
            ' down-right
            palID = (attByte And &HC0) \ &H40
            tileID = rom(addr + 10)
                BitBlt panel.hDC, dX + 16, dY + 16, 8, 8, _
                parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 11)
                BitBlt panel.hDC, dX + 24, dY + 16, 8, 8, _
                parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 14)
                BitBlt panel.hDC, dX + 16, dY + 24, 8, 8, _
                parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY
            tileID = rom(addr + 15)
                BitBlt panel.hDC, dX + 24, dY + 24, 8, 8, _
                parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, SRCCOPY

        Next X
        DoEvents
    Next Y
    panel.Visible = True: panel.Refresh

End Function

' draws a single part of the field using chr() and pal(), no blit (slower)
Public Function redrawFieldMetatile(panel As PictureBox, X As Integer, Y As Integer, _
                          rom() As Byte, nchr() As Byte, npal() As Byte)

    Dim dX As Long, dY As Long
    Dim addr As Long
    Dim metaID As Byte, attByte As Byte, palID As Byte
    
    dY = Y * 32
    dX = X * 32

    metaID = rom(MAPDATA_ADDR + (Y * 24) + X)
    attByte = rom(ATTDATA_ADDR + (Y * 24) + X)
    addr = METADATA_ADDR + (metaID * &H10&)

    palID = (attByte And &H3)
    draw2BPPTile_Fast nchr(), rom(addr + 0), panel, dX + 0, dY + 0, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 1), panel, dX + 8, dY + 0, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 4), panel, dX + 0, dY + 8, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 5), panel, dX + 8, dY + 8, npal(), palID
    
    palID = (attByte And &HC) \ &H4
    draw2BPPTile_Fast nchr(), rom(addr + 2), panel, dX + 16, dY + 0, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 3), panel, dX + 24, dY + 0, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 6), panel, dX + 16, dY + 8, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 7), panel, dX + 24, dY + 8, npal(), palID
    
    palID = (attByte And &H30) \ &H10
    draw2BPPTile_Fast nchr(), rom(addr + 8), panel, dX + 0, dY + 16, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 9), panel, dX + 8, dY + 16, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 12), panel, dX + 0, dY + 24, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 13), panel, dX + 8, dY + 24, npal(), palID
    
    palID = (attByte And &HC0) \ &H40
    draw2BPPTile_Fast nchr(), rom(addr + 10), panel, dX + 16, dY + 16, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 11), panel, dX + 24, dY + 16, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 14), panel, dX + 16, dY + 24, npal(), palID
    draw2BPPTile_Fast nchr(), rom(addr + 15), panel, dX + 24, dY + 24, npal(), palID
    
    panel.Refresh

End Function


'#############################################################################################
'
Public Function drawBatterView(panel As PictureBox, rom() As Byte, _
                                parent As Form)

    Dim X As Integer, Y As Integer
    Dim tileID As Byte, palID As Byte
    
    panel.Visible = False: panel.Cls
    For Y = 0 To 30
    For X = 0 To 32
    
        tileID = rom(BATVIEW_ADDR + (Y * 32) + X)
        BitBlt panel.hDC, X * 8, Y * 8, 8, 8, _
            parent.picPatTbl(palID).hDC, (tileID And &HF) * 8, (tileID And &HF0) \ 2, _
            SRCCOPY

    Next X
    Next Y
    panel.Visible = True: panel.Refresh

End Function



































'#############################################################################################
' this function coverts "numOfTiles" amount of tiles from "src"
' starting at "addr." all data is written to "dest."
'   2bpp -> 8bpp (non-interleaved)
'
' 0=ok
' 1=unknown
Public Function convertFrom2BPP(ByVal srcaddr As Long, ByVal numOfTiles As Integer, _
                ByRef dest() As Byte, _
                ByRef src() As Byte) As Integer

    Dim lenOfArray As Long
    Dim byte0 As Byte, byte1 As Byte
    Dim t As Integer, r As Integer
    
    'On Error GoTo err

    ' resize array if too small
    lenOfArray = (numOfTiles * REND_SIZEOFTILE) - 1
    ReDim dest(lenOfArray)

    ' convert data
    For t = 0 To (numOfTiles - 1)
        For r = 0 To 7
            byte0 = src(srcaddr + (t * 16) + r)
            byte1 = src(srcaddr + (t * 16) + r + 8)
            dest((t * 64) + (r * 8) + 7) = (byte0 And &H1) + ((byte1 And &H1) * &H2)
            dest((t * 64) + (r * 8) + 6) = ((byte0 And &H2) / &H2) + (byte1 And &H2)
            dest((t * 64) + (r * 8) + 5) = ((byte0 And &H4) / &H4) + ((byte1 And &H4) / &H2)
            dest((t * 64) + (r * 8) + 4) = ((byte0 And &H8) / &H8) + ((byte1 And &H8) / &H4)
            dest((t * 64) + (r * 8) + 3) = ((byte0 And &H10) / &H10) + ((byte1 And &H10) / &H8)
            dest((t * 64) + (r * 8) + 2) = ((byte0 And &H20) / &H20) + ((byte1 And &H20) / &H10)
            dest((t * 64) + (r * 8) + 1) = ((byte0 And &H40) / &H40) + ((byte1 And &H40) / &H20)
            dest((t * 64) + (r * 8) + 0) = ((byte0 And &H80) / &H80) + ((byte1 And &H80) / &H40)
        Next r
    Next t

    convertFrom2BPP = 0
    Exit Function

err:
    convertFrom2BPP = 1

End Function

Public Function convertTo2BPP(ByVal destaddr As Long, ByVal numOfTiles As Integer, _
                                ByRef src() As Byte, _
                                ByRef dest() As Byte)

    Dim t As Integer, src_ptr As Long, dest_ptr As Long
    Dim lenOfArray As Long

    lenOfArray = (numOfTiles * NES_SIZEOFTILE) - 1
    ReDim dest(lenOfArray)
    ' convert data
    src_ptr = 0
    dest_ptr = destaddr
    For t = 0 To (numOfTiles - 1)
        ' plane 0
        dest(dest_ptr + 0) = _
                ((src(src_ptr + 0) And 1) * &H80) Or ((src(src_ptr + 1) And 1) * &H40) Or _
                ((src(src_ptr + 2) And 1) * &H20) Or ((src(src_ptr + 3) And 1) * &H10) Or _
                ((src(src_ptr + 4) And 1) * &H8) Or ((src(src_ptr + 5) And 1) * &H4) Or _
                ((src(src_ptr + 6) And 1) * &H2) Or ((src(src_ptr + 7) And 1) * &H1)
        dest(dest_ptr + 1) = _
                ((src(src_ptr + 8) And 1) * &H80) Or ((src(src_ptr + 9) And 1) * &H40) Or _
                ((src(src_ptr + 10) And 1) * &H20) Or ((src(src_ptr + 11) And 1) * &H10) Or _
                ((src(src_ptr + 12) And 1) * &H8) Or ((src(src_ptr + 13) And 1) * &H4) Or _
                ((src(src_ptr + 14) And 1) * &H2) Or ((src(src_ptr + 15) And 1) * &H1)
        dest(dest_ptr + 2) = _
                ((src(src_ptr + 16) And 1) * &H80) Or ((src(src_ptr + 17) And 1) * &H40) Or _
                ((src(src_ptr + 18) And 1) * &H20) Or ((src(src_ptr + 19) And 1) * &H10) Or _
                ((src(src_ptr + 20) And 1) * &H8) Or ((src(src_ptr + 21) And 1) * &H4) Or _
                ((src(src_ptr + 22) And 1) * &H2) Or ((src(src_ptr + 23) And 1) * &H1)
        dest(dest_ptr + 3) = _
                ((src(src_ptr + 24) And 1) * &H80) Or ((src(src_ptr + 25) And 1) * &H40) Or _
                ((src(src_ptr + 26) And 1) * &H20) Or ((src(src_ptr + 27) And 1) * &H10) Or _
                ((src(src_ptr + 28) And 1) * &H8) Or ((src(src_ptr + 29) And 1) * &H4) Or _
                ((src(src_ptr + 30) And 1) * &H2) Or ((src(src_ptr + 31) And 1) * &H1)
        dest(dest_ptr + 4) = _
                ((src(src_ptr + 32) And 1) * &H80) Or ((src(src_ptr + 33) And 1) * &H40) Or _
                ((src(src_ptr + 34) And 1) * &H20) Or ((src(src_ptr + 35) And 1) * &H10) Or _
                ((src(src_ptr + 36) And 1) * &H8) Or ((src(src_ptr + 37) And 1) * &H4) Or _
                ((src(src_ptr + 38) And 1) * &H2) Or ((src(src_ptr + 39) And 1) * &H1)
        dest(dest_ptr + 5) = _
                ((src(src_ptr + 40) And 1) * &H80) Or ((src(src_ptr + 41) And 1) * &H40) Or _
                ((src(src_ptr + 42) And 1) * &H20) Or ((src(src_ptr + 43) And 1) * &H10) Or _
                ((src(src_ptr + 44) And 1) * &H8) Or ((src(src_ptr + 45) And 1) * &H4) Or _
                ((src(src_ptr + 46) And 1) * &H2) Or ((src(src_ptr + 47) And 1) * &H1)
        dest(dest_ptr + 6) = _
                ((src(src_ptr + 48) And 1) * &H80) Or ((src(src_ptr + 49) And 1) * &H40) Or _
                ((src(src_ptr + 50) And 1) * &H20) Or ((src(src_ptr + 51) And 1) * &H10) Or _
                ((src(src_ptr + 52) And 1) * &H8) Or ((src(src_ptr + 53) And 1) * &H4) Or _
                ((src(src_ptr + 54) And 1) * &H2) Or ((src(src_ptr + 55) And 1) * &H1)
        dest(dest_ptr + 7) = _
                ((src(src_ptr + 56) And 1) * &H80) Or ((src(src_ptr + 57) And 1) * &H40) Or _
                ((src(src_ptr + 58) And 1) * &H20) Or ((src(src_ptr + 59) And 1) * &H10) Or _
                ((src(src_ptr + 60) And 1) * &H8) Or ((src(src_ptr + 61) And 1) * &H4) Or _
                ((src(src_ptr + 62) And 1) * &H2) Or ((src(src_ptr + 63) And 1) * &H1)
        
        ' plane 1
        dest(dest_ptr + 8) = _
                ((src(src_ptr + 0) And 2) * &H40) Or ((src(src_ptr + 1) And 2) * &H20) Or _
                ((src(src_ptr + 2) And 2) * &H10) Or ((src(src_ptr + 3) And 2) * &H8) Or _
                ((src(src_ptr + 4) And 2) * &H4) Or ((src(src_ptr + 5) And 2) * &H2) Or _
                ((src(src_ptr + 6) And 2) * &H1) Or ((src(src_ptr + 7) And 2) / &H2)
        dest(dest_ptr + 9) = _
                ((src(src_ptr + 8) And 2) * &H40) Or ((src(src_ptr + 9) And 2) * &H20) Or _
                ((src(src_ptr + 10) And 2) * &H10) Or ((src(src_ptr + 11) And 2) * &H8) Or _
                ((src(src_ptr + 12) And 2) * &H4) Or ((src(src_ptr + 13) And 2) * &H2) Or _
                ((src(src_ptr + 14) And 2) * &H1) Or ((src(src_ptr + 15) And 2) / &H2)
        dest(dest_ptr + 10) = _
                ((src(src_ptr + 16) And 2) * &H40) Or ((src(src_ptr + 17) And 2) * &H20) Or _
                ((src(src_ptr + 18) And 2) * &H10) Or ((src(src_ptr + 19) And 2) * &H8) Or _
                ((src(src_ptr + 20) And 2) * &H4) Or ((src(src_ptr + 21) And 2) * &H2) Or _
                ((src(src_ptr + 22) And 2) * &H1) Or ((src(src_ptr + 23) And 2) / &H2)
        dest(dest_ptr + 11) = _
                ((src(src_ptr + 24) And 2) * &H40) Or ((src(src_ptr + 25) And 2) * &H20) Or _
                ((src(src_ptr + 26) And 2) * &H10) Or ((src(src_ptr + 27) And 2) * &H8) Or _
                ((src(src_ptr + 28) And 2) * &H4) Or ((src(src_ptr + 29) And 2) * &H2) Or _
                ((src(src_ptr + 30) And 2) * &H1) Or ((src(src_ptr + 31) And 2) / &H2)
        dest(dest_ptr + 12) = _
                ((src(src_ptr + 32) And 2) * &H40) Or ((src(src_ptr + 33) And 2) * &H20) Or _
                ((src(src_ptr + 34) And 2) * &H10) Or ((src(src_ptr + 35) And 2) * &H8) Or _
                ((src(src_ptr + 36) And 2) * &H4) Or ((src(src_ptr + 37) And 2) * &H2) Or _
                ((src(src_ptr + 38) And 2) * &H1) Or ((src(src_ptr + 39) And 2) / &H2)
        dest(dest_ptr + 13) = _
                ((src(src_ptr + 40) And 2) * &H40) Or ((src(src_ptr + 41) And 2) * &H20) Or _
                ((src(src_ptr + 42) And 2) * &H10) Or ((src(src_ptr + 43) And 2) * &H8) Or _
                ((src(src_ptr + 44) And 2) * &H4) Or ((src(src_ptr + 45) And 2) * &H2) Or _
                ((src(src_ptr + 46) And 2) * &H1) Or ((src(src_ptr + 47) And 2) / &H2)
        dest(dest_ptr + 14) = _
                ((src(src_ptr + 48) And 2) * &H40) Or ((src(src_ptr + 49) And 2) * &H20) Or _
                ((src(src_ptr + 50) And 2) * &H10) Or ((src(src_ptr + 51) And 2) * &H8) Or _
                ((src(src_ptr + 52) And 2) * &H4) Or ((src(src_ptr + 53) And 2) * &H2) Or _
                ((src(src_ptr + 54) And 2) * &H1) Or ((src(src_ptr + 55) And 2) / &H2)
        dest(dest_ptr + 15) = _
                ((src(src_ptr + 56) And 2) * &H40) Or ((src(src_ptr + 57) And 2) * &H20) Or _
                ((src(src_ptr + 58) And 2) * &H10) Or ((src(src_ptr + 59) And 2) * &H8) Or _
                ((src(src_ptr + 60) And 2) * &H4) Or ((src(src_ptr + 61) And 2) * &H2) Or _
                ((src(src_ptr + 62) And 2) * &H1) Or ((src(src_ptr + 63) And 2) / &H2)
        
        src_ptr = (src_ptr + REND_SIZEOFTILE)
        dest_ptr = (dest_ptr + 16)
    Next t

End Function



















'#############################################################################################
Public Function copyTileToTile(ByRef src() As Byte, ByVal src_id As Byte, _
                               ByRef dest() As Byte, ByVal dest_id As Byte)
                               
    Dim i As Integer
    Dim src_addr As Long, dest_addr As Long
    
    src_addr = (REND_SIZEOFTILE * src_id)
    dest_addr = (REND_SIZEOFTILE * dest_id)
    
    For i = 0 To 63
        dest(dest_addr + i) = src(src_addr + i)
    Next i

End Function

Public Function shiftTile(ByRef src() As Byte, ByVal src_id As Byte, _
                          ByVal shift_x As Integer, shift_y As Integer)

    Dim tempTile(63) As Byte, shiftedTile(63) As Byte
    Dim src_addr As Long, i As Integer

    ' read data
    src_addr = (REND_SIZEOFTILE * src_id)
    For i = 0 To 63
        tempTile(i) = src(src_addr + i)
    Next i
    
    'shift data
    For i = 0 To 63
        shiftedTile(i) = tempTile((((shift_x + i) And &H7) + (shift_y * 8) + (i And &H38)) And &H3F)
    Next i

    ' write data
    For i = 0 To 63
        src(src_addr + i) = shiftedTile(i)
    Next i

End Function

Public Function flipTile(ByRef src() As Byte, ByVal src_id As Byte, _
                         ByVal flip_v As Boolean, ByVal flip_h As Boolean)
                         
    Dim tempTile(63) As Byte, flippedTile(63) As Byte
    Dim src_addr As Long, i As Integer
    
    ' read data
    src_addr = (REND_SIZEOFTILE * src_id)
    For i = 0 To 63
        tempTile(i) = src(src_addr + i)
    Next i
    
    ' flip data
    If (flip_v) Then
        For i = 0 To 63
            flippedTile(i) = tempTile((((i \ 8) + 1) * 8) - 1 - (i And 7))
        Next i
        If (flip_h) Then
            For i = 0 To 63
                tempTile(i) = flippedTile(i)
            Next i
        End If
    End If
    If (flip_h) Then
        For i = 0 To 63
            flippedTile(i) = tempTile((((7 - (i \ 8)) * 8) + (i And 7)))
        Next i
    End If
    
    ' write data
    For i = 0 To 63
        src(src_addr + i) = flippedTile(i)
    Next i

End Function

Public Function rotateTile45(ByRef src() As Byte, ByVal src_id As Byte)

    Dim tempTile(63) As Byte, rotatedTile(63) As Byte
    Dim src_addr As Long, i As Integer
    Dim X As Integer, Y As Integer
    
    ' read data
    src_addr = (REND_SIZEOFTILE * src_id)
    For i = 0 To 63
        tempTile(i) = src(src_addr + i)
    Next i
    
    ' rotate data
    For Y = 0 To 7
        For X = 0 To 7
            rotatedTile((Y * 8) + X) = tempTile((X * 8) + Y)
        Next X
    Next Y

    ' write data
    For i = 0 To 63
        src(src_addr + i) = rotatedTile(i)
    Next i
    Call flipTile(src, src_id, False, True)

End Function

Public Function clearTileRange(ByRef src() As Byte, ByVal start_id As Byte, ByVal end_id As Byte)
    Dim i As Integer
    For i = start_id To end_id
        Call clearTile(src, i)
    Next i
End Function

Public Function clearTile(ByRef src() As Byte, ByVal src_id As Byte)
    Dim src_addr As Long, i As Integer

    src_addr = (REND_SIZEOFTILE * src_id)
    For i = 0 To 63
        src(src_addr + i) = 0
    Next i
End Function


Public Function swapBkgPal(src() As Byte, ByVal pal0 As Integer, ByVal pal1 As Integer, _
                            ByVal start_id As Integer, tile_count As Integer)
    Dim src_addr As Long, tile_id As Integer
    Dim i As Integer

    For tile_id = start_id To (start_id + tile_count)
        If ((tile_id < 0) Or (tile_id > &HFF)) Then Exit For
        src_addr = (REND_SIZEOFTILE * tile_id)

        For i = 0 To 63
            If (src(src_addr + i) = pal0) Then
                src(src_addr + i) = pal1
            ElseIf (src(src_addr + i) = pal1) Then
                src(src_addr + i) = pal0
            End If
        Next i
    Next tile_id

End Function































'#############################################################################################
' Input: hex value from the nes palette
' Output: the RGB value of the nes palette
Public Function Hex2Color(ByVal HexVal As Byte, ByVal monochrome As Boolean, ByVal emphasis As Byte) As Long

    Dim emp_r As Double, emp_g As Double, emp_b As Double

    ' account for greyscale mode
    If (monochrome) Then
        HexVal = (HexVal And &H30)
        emp_r = 1: emp_g = 1: emp_b = 1
    Else
        ' emphasis factors, %000 to %111. r,g,b
        ' measurement by Quietust
        ' {1.00, 1.00, 1.00}
        ' {1.00, 0.80, 0.81}
        ' {0.78, 0.94, 0.66}
        ' {0.79, 0.77, 0.63}
        ' {0.82, 0.83, 1.12}
        ' {0.81, 0.71, 0.87}
        ' {0.68, 0.79, 0.79}
        ' {0.70, 0.70, 0.70}
        Select Case (emphasis And 7)
            Case 0: emp_r = 1: emp_g = 1: emp_b = 1
            Case 1: emp_r = 1: emp_g = 0.8: emp_b = 0.81
            Case 2: emp_r = 0.78: emp_g = 0.94: emp_b = 0.66
            Case 3: emp_r = 0.79: emp_g = 0.77: emp_b = 0.63
            Case 4: emp_r = 0.82: emp_g = 0.83: emp_b = 1.12
            Case 5: emp_r = 0.81: emp_g = 0.71: emp_b = 0.87
            Case 6: emp_r = 0.68: emp_g = 0.79: emp_b = 0.79
            Case 7: emp_r = 0.7: emp_g = 0.7: emp_b = 0.7
        End Select
    End If

    ' get an approximation of the rgb value of PPU palette entry
    Select Case HexVal
        Case &H0
            Hex2Color = RGB(&H80 * emp_r, &H80 * emp_g, &H80 * emp_b)
        Case &H1
            Hex2Color = RGB(&H0 * emp_r, &H3D * emp_g, &HA6 * emp_b)
        Case &H2
            Hex2Color = RGB(&H0 * emp_r, &H12 * emp_g, &HB0 * emp_b)
        Case &H3
            Hex2Color = RGB(&H44 * emp_r, &H0 * emp_g, &H96 * emp_b)
        Case &H4
            Hex2Color = RGB(&HA1 * emp_r, &H0 * emp_g, &H5E * emp_b)
        Case &H5
            Hex2Color = RGB(&HC7 * emp_r, &H0 * emp_g, &H28 * emp_b)
        Case &H6
            Hex2Color = RGB(&HBA * emp_r, &H6 * emp_g, &H0 * emp_b)
        Case &H7
            Hex2Color = RGB(&H8C * emp_r, &H17 * emp_g, &H0 * emp_b)
        Case &H8
            Hex2Color = RGB(&H5C * emp_r, &H2F * emp_g, &H0 * emp_b)
        Case &H9
            Hex2Color = RGB(&H10 * emp_r, &H45 * emp_g, &H0 * emp_b)
        Case &HA
            Hex2Color = RGB(&H5 * emp_r, &H4A * emp_g, &H0 * emp_b)
        Case &HB
            Hex2Color = RGB(&H0 * emp_r, &H47 * emp_g, &H2E * emp_b)
        Case &HC
            Hex2Color = RGB(&H0 * emp_r, &H41 * emp_g, &H66 * emp_b)
        Case &HD
            Hex2Color = RGB(&H0 * emp_r, &H0 * emp_g, &H0 * emp_b)
        Case &HE
            Hex2Color = RGB(&H5 * emp_r, &H5 * emp_g, &H5 * emp_b)
        Case &HF
            Hex2Color = RGB(&H5 * emp_r, &H5 * emp_g, &H5 * emp_b)
        Case &H10
            Hex2Color = RGB(&HC7 * emp_r, &HC7 * emp_g, &HC7 * emp_b)
        Case &H11
            Hex2Color = RGB(&H0 * emp_r, &H77 * emp_g, &HFF * emp_b)
        Case &H12
            Hex2Color = RGB(&H21 * emp_r, &H55 * emp_g, &HFF * emp_b)
        Case &H13
            Hex2Color = RGB(&H82 * emp_r, &H37 * emp_g, &HFA * emp_b)
        Case &H14
            Hex2Color = RGB(&HEB * emp_r, &H2F * emp_g, &HB5 * emp_b)
        Case &H15
            Hex2Color = RGB(&HFF * emp_r, &H29 * emp_g, &H50 * emp_b)
        Case &H16
            Hex2Color = RGB(&HFF * emp_r, &H22 * emp_g, &H0 * emp_b)
        Case &H17
            Hex2Color = RGB(&HD6 * emp_r, &H32 * emp_g, &H0 * emp_b)
        Case &H18
            Hex2Color = RGB(&HC4 * emp_r, &H62 * emp_g, &H0 * emp_b)
        Case &H19
            Hex2Color = RGB(&H35 * emp_r, &H80 * emp_g, &H0 * emp_b)
        Case &H1A
            Hex2Color = RGB(&H5 * emp_r, &H8F * emp_g, &H0 * emp_b)
        Case &H1B
            Hex2Color = RGB(&H0 * emp_r, &H8A * emp_g, &H55 * emp_b)
        Case &H1C
            Hex2Color = RGB(&H0 * emp_r, &H99 * emp_g, &HCC * emp_b)
        Case &H1D
            Hex2Color = RGB(&H21 * emp_r, &H21 * emp_g, &H21 * emp_b)
        Case &H1E
            Hex2Color = RGB(&H9 * emp_r, &H9 * emp_g, &H9 * emp_b)
        Case &H1F
            Hex2Color = RGB(&H9 * emp_r, &H9 * emp_g, &H9 * emp_b)
        Case &H20
            Hex2Color = RGB(&HFF * emp_r, &HFF * emp_g, &HFF * emp_b)
        Case &H21
            Hex2Color = RGB(&HF * emp_r, &HD7 * emp_g, &HFF * emp_b)
        Case &H22
            Hex2Color = RGB(&H69 * emp_r, &HA2 * emp_g, &HFF * emp_b)
        Case &H23
            Hex2Color = RGB(&HD4 * emp_r, &H80 * emp_g, &HFF * emp_b)
        Case &H24
            Hex2Color = RGB(&HFF * emp_r, &H45 * emp_g, &HF3 * emp_b)
        Case &H25
            Hex2Color = RGB(&HFF * emp_r, &H61 * emp_g, &H8B * emp_b)
        Case &H26
            Hex2Color = RGB(&HFF * emp_r, &H88 * emp_g, &H33 * emp_b)
        Case &H27
            Hex2Color = RGB(&HFF * emp_r, &H9C * emp_g, &H12 * emp_b)
        Case &H28
            Hex2Color = RGB(&HFA * emp_r, &HBC * emp_g, &H20 * emp_b)
        Case &H29
            Hex2Color = RGB(&H9F * emp_r, &HE3 * emp_g, &HE * emp_b)
        Case &H2A
            Hex2Color = RGB(&H2B * emp_r, &HF0 * emp_g, &H35 * emp_b)
        Case &H2B
            Hex2Color = RGB(&HC * emp_r, &HF0 * emp_g, &HA4 * emp_b)
        Case &H2C
            Hex2Color = RGB(&H5 * emp_r, &HFB * emp_g, &HFF * emp_b)
        Case &H2D
            Hex2Color = RGB(&H5E * emp_r, &H5E * emp_g, &H5E * emp_b)
        Case &H2E
            Hex2Color = RGB(&HD * emp_r, &HD * emp_g, &HD * emp_b)
        Case &H2F
            Hex2Color = RGB(&HD * emp_r, &HD * emp_g, &HD * emp_b)
        Case &H30
            Hex2Color = RGB(&HFF * emp_r, &HFF * emp_g, &HFF * emp_b)
        Case &H31
            Hex2Color = RGB(&HA6 * emp_r, &HFC * emp_g, &HFF * emp_b)
        Case &H32
            Hex2Color = RGB(&HB3 * emp_r, &HEC * emp_g, &HFF * emp_b)
        Case &H33
            Hex2Color = RGB(&HDA * emp_r, &HAB * emp_g, &HEB * emp_b)
        Case &H34
            Hex2Color = RGB(&HFF * emp_r, &HA8 * emp_g, &HF9 * emp_b)
        Case &H35
            Hex2Color = RGB(&HFF * emp_r, &HAB * emp_g, &HB3 * emp_b)
        Case &H36
            Hex2Color = RGB(&HFF * emp_r, &HD2 * emp_g, &HB0 * emp_b)
        Case &H37
            Hex2Color = RGB(&HFF * emp_r, &HEF * emp_g, &HA6 * emp_b)
        Case &H38
            Hex2Color = RGB(&HFF * emp_r, &HF7 * emp_g, &H9C * emp_b)
        Case &H39
            Hex2Color = RGB(&HD7 * emp_r, &HE8 * emp_g, &H95 * emp_b)
        Case &H3A
            Hex2Color = RGB(&HA6 * emp_r, &HED * emp_g, &HAF * emp_b)
        Case &H3B
            Hex2Color = RGB(&HA2 * emp_r, &HF2 * emp_g, &HDA * emp_b)
        Case &H3C
            Hex2Color = RGB(&H99 * emp_r, &HFF * emp_g, &HFC * emp_b)
        Case &H3D
            Hex2Color = RGB(&HDD * emp_r, &HDD * emp_g, &HDD * emp_b)
        Case &H3E
            Hex2Color = RGB(&H11 * emp_r, &H11 * emp_g, &H11 * emp_b)
        Case &H3F
            Hex2Color = RGB(&H11 * emp_r, &H11 * emp_g, &H11 * emp_b)
    End Select

End Function

