Attribute VB_Name = "modGlobl"
Public Const BATVIEW_ADDR = &H1010&

Public Const MAPDATA_ADDR = &H8010&
Public Const ATTDATA_ADDR = &H8250&
Public Const METADATA_ADDR = &H8490&

Public Const FIELDPAL_ADDR = &H9ED6&
Public Const BATTERPAL_ADDR = &HB7A1&

Public Const FIELDBKG_ADDR = &H15010
Public Const BATBKG_ADDR = &H17010





Public Const MAX_META_ID = &H84&

Public Enum ALTPANE
    VIEW_MT
    VIEW_BAT
End Enum


Public Type POINTAPI
    X As Integer
    Y As Integer
End Type


Public prj_rom() As Byte


Option Explicit

'#############################################################################################
'
' read rom image from disk
'
'   args:       <string>    filename
'               <byte()>    header dest
'               <byte()>    rom dest
'
'   ret:        0=good
'               1=i/o error
'
Public Function loadArrayFromFile(ByVal Filename As String, dest() As Byte) As Integer
    
    On Error GoTo err
    Dim nFileNum As Integer, file_length As Long
    
    nFileNum = FreeFile
    If (Not CheckPath(Filename)) Then
        loadArrayFromFile = 1
        Exit Function
    End If
    Open Filename For Binary As nFileNum
        file_length = LOF(nFileNum)
        If (UBound(dest()) <> (file_length - 1)) Then
            ReDim dest(file_length - 1)
        End If
        Get #nFileNum, &H0& + 1, dest
    Close nFileNum
    loadArrayFromFile = 0
    Exit Function

err:
    loadArrayFromFile = 1

End Function


'#############################################################################################
'
' write rom image to disk
'
'   args:       <string>    filename
'               <byte()>    header dest
'               <byte()>    rom dest
'
'   ret:        0=good
'               1=i/o error
'
Public Function saveArrayToFile(ByVal Filename As String, src() As Byte) As Integer

    On Error GoTo err
    Dim nFileNum As Integer
    
    nFileNum = FreeFile
    Open Filename For Binary As nFileNum
        Put #nFileNum, &H0& + 1, src
    Close nFileNum
    saveArrayToFile = 0
    Exit Function
    
err:
    saveArrayToFile = 1

End Function







'#############################################################################################
'
Public Function CheckPath(ByVal strPath As String) As Boolean
    If Dir$(strPath) <> "" Then
        CheckPath = True
    Else
        CheckPath = False
    End If
End Function

Public Function getFileTitle(ByVal Filename As String) As String
    Dim fIndex As Integer
    fIndex = InStrRev(Filename, "\")
    If (fIndex >= 0) Then
        getFileTitle = Right(Filename, Len(Filename) - fIndex)
    Else
        getFileTitle = Filename
    End If
End Function

Public Function getFilePath(ByVal Filename As String) As String
    Dim fIndex As Integer
    fIndex = InStrRev(Filename, "\")
    If (fIndex >= 0) Then
        getFilePath = Left(Filename, fIndex)
    Else
        getFilePath = Filename
    End If
End Function

